/*!
 * Copyright (c) 2016 Chris O'Hara <cohara87@gmail.com>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.validator=t()}(this,function(){"use strict";function e(e){if("string"!=typeof e)throw new TypeError("This library (validator.js) validates strings only")}function t(t){return e(t),t=Date.parse(t),isNaN(t)?null:new Date(t)}function r(t){return e(t),parseFloat(t)}function o(t,r){return e(t),parseInt(t,r||10)}function n(t,r){return e(t),r?"1"===t||"true"===t:"0"!==t&&"false"!==t&&""!==t}function i(t,r){return e(t),t===r}function l(e){return"object"===("undefined"==typeof e?"undefined":de(e))&&null!==e?e="function"==typeof e.toString?e.toString():"[object Object]":(null===e||"undefined"==typeof e||isNaN(e)&&!e.length)&&(e=""),String(e)}function a(t,r){return e(t),t.indexOf(l(r))>=0}function u(t,r,o){return e(t),"[object RegExp]"!==Object.prototype.toString.call(r)&&(r=new RegExp(r,o)),r.test(t)}function s(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments[1];for(var r in t)"undefined"==typeof e[r]&&(e[r]=t[r]);return e}function c(t,r){e(t);var o=void 0,n=void 0;"object"===("undefined"==typeof r?"undefined":de(r))?(o=r.min||0,n=r.max):(o=arguments[1],n=arguments[2]);var i=encodeURI(t).split(/%..|./).length-1;return i>=o&&("undefined"==typeof n||i<=n)}function f(t,r){e(t),r=s(r,pe),r.allow_trailing_dot&&"."===t[t.length-1]&&(t=t.substring(0,t.length-1));var o=t.split(".");if(r.require_tld){var n=o.pop();if(!o.length||!/^([a-z\u00a1-\uffff]{2,}|xn[a-z0-9-]{2,})$/i.test(n))return!1}for(var i,l=0;l<o.length;l++){if(i=o[l],r.allow_underscores&&(i=i.replace(/_/g,"")),!/^[a-z\u00a1-\uffff0-9-]+$/i.test(i))return!1;if(/[\uff01-\uff5e]/.test(i))return!1;if("-"===i[0]||"-"===i[i.length-1])return!1}return!0}function d(t,r){if(e(t),r=s(r,he),r.require_display_name||r.allow_display_name){var o=t.match(ge);if(o)t=o[1];else if(r.require_display_name)return!1}var n=t.split("@"),i=n.pop(),l=n.join("@"),a=i.toLowerCase();if("gmail.com"!==a&&"googlemail.com"!==a||(l=l.replace(/\./g,"").toLowerCase()),!c(l,{max:64})||!c(i,{max:256}))return!1;if(!f(i,{require_tld:r.require_tld}))return!1;if('"'===l[0])return l=l.slice(1,l.length-1),r.allow_utf8_local_part?Fe.test(l):_e.test(l);for(var u=r.allow_utf8_local_part?ve:me,d=l.split("."),p=0;p<d.length;p++)if(!u.test(d[p]))return!1;return!0}function p(t){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";if(e(t),r=String(r),!r)return p(t,4)||p(t,6);if("4"===r){if(!$e.test(t))return!1;var o=t.split(".").sort(function(e,t){return e-t});return o[3]<=255}if("6"===r){var n=t.split(":"),i=!1,l=p(n[n.length-1],4),a=l?7:8;if(n.length>a)return!1;if("::"===t)return!0;"::"===t.substr(0,2)?(n.shift(),n.shift(),i=!0):"::"===t.substr(t.length-2)&&(n.pop(),n.pop(),i=!0);for(var u=0;u<n.length;++u)if(""===n[u]&&u>0&&u<n.length-1){if(i)return!1;i=!0}else if(l&&u===n.length-1);else if(!xe.test(n[u]))return!1;return i?n.length>=1:n.length===a}return!1}function h(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function g(e,t){for(var r=0;r<t.length;r++){var o=t[r];if(e===o||h(o)&&o.test(e))return!0}return!1}function m(t,r){if(e(t),!t||t.length>=2083||/[\s<>]/.test(t))return!1;if(0===t.indexOf("mailto:"))return!1;r=s(r,ye);var o=void 0,n=void 0,i=void 0,l=void 0,a=void 0,u=void 0,c=void 0,d=void 0;if(c=t.split("#"),t=c.shift(),c=t.split("?"),t=c.shift(),c=t.split("://"),c.length>1){if(o=c.shift(),r.require_valid_protocol&&r.protocols.indexOf(o)===-1)return!1}else{if(r.require_protocol)return!1;r.allow_protocol_relative_urls&&"//"===t.substr(0,2)&&(c[0]=t.substr(2))}if(t=c.join("://"),c=t.split("/"),t=c.shift(),""===t&&!r.require_host)return!0;if(c=t.split("@"),c.length>1&&(n=c.shift(),n.indexOf(":")>=0&&n.split(":").length>2))return!1;l=c.join("@"),u=d=null;var h=l.match(we);return h?(i="",d=h[1],u=h[2]||null):(c=l.split(":"),i=c.shift(),c.length&&(u=c.join(":"))),!(null!==u&&(a=parseInt(u,10),!/^[0-9]+$/.test(u)||a<=0||a>65535))&&(!!(p(i)||f(i,r)||d&&p(d,6)||"localhost"===i)&&(i=i||d,!(r.host_whitelist&&!g(i,r.host_whitelist))&&(!r.host_blacklist||!g(i,r.host_blacklist))))}function _(t){return e(t),Ae.test(t)}function v(t){return e(t),["true","false","1","0"].indexOf(t)>=0}function F(t){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"en-US";if(e(t),r in be)return be[r].test(t);throw new Error("Invalid locale '"+r+"'")}function $(t){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"en-US";if(e(t),r in ke)return ke[r].test(t);throw new Error("Invalid locale '"+r+"'")}function x(t){return e(t),Ie.test(t)}function y(t){return e(t),t===t.toLowerCase()}function w(t){return e(t),t===t.toUpperCase()}function A(t){return e(t),Ce.test(t)}function b(t){return e(t),Re.test(t)}function k(t){return e(t),je.test(t)}function S(t){return e(t),Re.test(t)&&je.test(t)}function D(t){return e(t),Pe.test(t)}function E(t){return e(t),Ue.test(t)}function Z(t,r){e(t),r=r||{};var o=r.hasOwnProperty("allow_leading_zeroes")&&!r.allow_leading_zeroes?ze:Ne,n=!r.hasOwnProperty("min")||t>=r.min,i=!r.hasOwnProperty("max")||t<=r.max,l=!r.hasOwnProperty("lt")||t<r.lt,a=!r.hasOwnProperty("gt")||t>r.gt;return o.test(t)&&n&&i&&l&&a}function O(t,r){return e(t),r=r||{},""!==t&&"."!==t&&(Be.test(t)&&(!r.hasOwnProperty("min")||t>=r.min)&&(!r.hasOwnProperty("max")||t<=r.max)&&(!r.hasOwnProperty("lt")||t<r.lt)&&(!r.hasOwnProperty("gt")||t>r.gt))}function I(t){return e(t),""!==t&&Le.test(t)}function C(t){return e(t),qe.test(t)}function R(t,o){return e(t),r(t)%parseInt(o,10)===0}function j(t){return e(t),Te.test(t)}function P(t){return e(t),He.test(t)}function U(t){e(t);try{var r=JSON.parse(t);return!!r&&"object"===("undefined"==typeof r?"undefined":de(r))}catch(e){}return!1}function z(t){return e(t),0===t.length}function N(t,r){e(t);var o=void 0,n=void 0;"object"===("undefined"==typeof r?"undefined":de(r))?(o=r.min||0,n=r.max):(o=arguments[1],n=arguments[2]);var i=t.match(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g)||[],l=t.length-i.length;return l>=o&&("undefined"==typeof n||l<=n)}function B(t){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"all";e(t);var o=Me[r];return o&&o.test(t)}function L(t){return e(t),C(t)&&24===t.length}function q(r){var o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:String(new Date);e(r);var n=t(o),i=t(r);return!!(i&&n&&i>n)}function T(r){var o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:String(new Date);e(r);var n=t(o),i=t(r);return!!(i&&n&&i<n)}function H(t,r){e(t);var o=void 0;if("[object Array]"===Object.prototype.toString.call(r)){var n=[];for(o in r)({}).hasOwnProperty.call(r,o)&&(n[o]=l(r[o]));return n.indexOf(t)>=0}return"object"===("undefined"==typeof r?"undefined":de(r))?r.hasOwnProperty(t):!(!r||"function"!=typeof r.indexOf)&&r.indexOf(t)>=0}function M(t){e(t);var r=t.replace(/[^0-9]+/g,"");if(!Ke.test(r))return!1;for(var o=0,n=void 0,i=void 0,l=void 0,a=r.length-1;a>=0;a--)n=r.substring(a,a+1),i=parseInt(n,10),l?(i*=2,o+=i>=10?i%10+1:i):o+=i,l=!l;return!(o%10!==0||!r)}function K(t){if(e(t),!We.test(t))return!1;for(var r=t.replace(/[A-Z]/g,function(e){return parseInt(e,36)}),o=0,n=void 0,i=void 0,l=!0,a=r.length-2;a>=0;a--)n=r.substring(a,a+1),i=parseInt(n,10),l?(i*=2,o+=i>=10?i+1:i):o+=i,l=!l;return parseInt(t.substr(t.length-1),10)===(1e4-o)%10}function W(t){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";if(e(t),r=String(r),!r)return W(t,10)||W(t,13);var o=t.replace(/[\s-]+/g,""),n=0,i=void 0;if("10"===r){if(!Ge.test(o))return!1;for(i=0;i<9;i++)n+=(i+1)*o.charAt(i);if(n+="X"===o.charAt(9)?100:10*o.charAt(9),n%11===0)return!!o}else if("13"===r){if(!Ye.test(o))return!1;for(i=0;i<12;i++)n+=Je[i%2]*o.charAt(i);if(o.charAt(12)-(10-n%10)%10===0)return!!o}return!1}function G(t){var r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};e(t);var o=Qe;if(o=r.require_hyphen?o.replace("?",""):o,o=r.case_sensitive?new RegExp(o):new RegExp(o,"i"),!o.test(t))return!1;var n=t.replace("-",""),i=8,l=0,a=!0,u=!1,s=void 0;try{for(var c,f=n[Symbol.iterator]();!(a=(c=f.next()).done);a=!0){var d=c.value,p="X"===d.toUpperCase()?10:+d;l+=p*i,--i}}catch(e){u=!0,s=e}finally{try{!a&&f.return&&f.return()}finally{if(u)throw s}}return l%11===0}function Y(t,r){return e(t),r in Xe&&Xe[r].test(t)}function J(e){var t="(\\"+e.symbol.replace(/\./g,"\\.")+")"+(e.require_symbol?"":"?"),r="-?",o="[1-9]\\d*",n="[1-9]\\d{0,2}(\\"+e.thousands_separator+"\\d{3})*",i=["0",o,n],l="("+i.join("|")+")?",a="(\\"+e.decimal_separator+"\\d{2})?",u=l+a;return e.allow_negatives&&!e.parens_for_negatives&&(e.negative_sign_after_digits?u+=r:e.negative_sign_before_digits&&(u=r+u)),e.allow_negative_sign_placeholder?u="( (?!\\-))?"+u:e.allow_space_after_symbol?u=" ?"+u:e.allow_space_after_digits&&(u+="( (?!$))?"),e.symbol_after_digits?u+=t:u=t+u,e.allow_negatives&&(e.parens_for_negatives?u="(\\("+u+"\\)|"+u+")":e.negative_sign_before_digits||e.negative_sign_after_digits||(u=r+u)),new RegExp("^(?!-? )(?=.*\\d)"+u+"$")}function Q(t,r){return e(t),r=s(r,Ve),J(r).test(t)}function X(t){return e(t),et.test(t)}function V(t){e(t);var r=t.length;if(!r||r%4!==0||tt.test(t))return!1;var o=t.indexOf("=");return o===-1||o===r-1||o===r-2&&"="===t[r-1]}function ee(t){return e(t),rt.test(t)}function te(t,r){e(t);var o=r?new RegExp("^["+r+"]+","g"):/^\s+/g;return t.replace(o,"")}function re(t,r){e(t);for(var o=r?new RegExp("["+r+"]"):/\s/,n=t.length-1;n>=0&&o.test(t[n]);)n--;return n<t.length?t.substr(0,n+1):t}function oe(e,t){return re(te(e,t),t)}function ne(t){return e(t),t.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\//g,"&#x2F;").replace(/\\/g,"&#x5C;").replace(/`/g,"&#96;")}function ie(t){return e(t),t.replace(/&amp;/g,"&").replace(/&quot;/g,'"').replace(/&#x27;/g,"'").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&#x2F;/g,"/").replace(/&#96;/g,"`")}function le(t,r){return e(t),t.replace(new RegExp("["+r+"]+","g"),"")}function ae(t,r){e(t);var o=r?"\\x00-\\x09\\x0B\\x0C\\x0E-\\x1F\\x7F":"\\x00-\\x1F\\x7F";return le(t,o)}function ue(t,r){return e(t),t.replace(new RegExp("[^"+r+"]+","g"),"")}function se(t,r){e(t);for(var o=t.length-1;o>=0;o--)if(r.indexOf(t[o])===-1)return!1;return!0}function ce(e,t){if(t=s(t,ot),!d(e))return!1;var r=e.split("@"),o=r.pop(),n=r.join("@"),i=[n,o];if(i[1]=i[1].toLowerCase(),"gmail.com"===i[1]||"googlemail.com"===i[1]){if(t.gmail_remove_subaddress&&(i[0]=i[0].split("+")[0]),t.gmail_remove_dots&&(i[0]=i[0].replace(/\./g,"")),!i[0].length)return!1;(t.all_lowercase||t.gmail_lowercase)&&(i[0]=i[0].toLowerCase()),i[1]=t.gmail_convert_googlemaildotcom?"gmail.com":i[1]}else if(~nt.indexOf(i[1])){if(t.icloud_remove_subaddress&&(i[0]=i[0].split("+")[0]),!i[0].length)return!1;(t.all_lowercase||t.icloud_lowercase)&&(i[0]=i[0].toLowerCase())}else if(~it.indexOf(i[1])){if(t.outlookdotcom_remove_subaddress&&(i[0]=i[0].split("+")[0]),!i[0].length)return!1;(t.all_lowercase||t.outlookdotcom_lowercase)&&(i[0]=i[0].toLowerCase())}else if(~lt.indexOf(i[1])){if(t.yahoo_remove_subaddress){var l=i[0].split("-");i[0]=l.length>1?l.slice(0,-1).join("-"):l[0]}if(!i[0].length)return!1;(t.all_lowercase||t.yahoo_lowercase)&&(i[0]=i[0].toLowerCase())}else t.all_lowercase&&(i[0]=i[0].toLowerCase());return i.join("@")}for(var fe,de="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},pe=(function(){function e(e){this.value=e}function t(t){function r(e,t){return new Promise(function(r,n){var a={key:e,arg:t,resolve:r,reject:n,next:null};l?l=l.next=a:(i=l=a,o(e,t))})}function o(r,i){try{var l=t[r](i),a=l.value;a instanceof e?Promise.resolve(a.value).then(function(e){o("next",e)},function(e){o("throw",e)}):n(l.done?"return":"normal",l.value)}catch(e){n("throw",e)}}function n(e,t){switch(e){case"return":i.resolve({value:t,done:!0});break;case"throw":i.reject(t);break;default:i.resolve({value:t,done:!1})}i=i.next,i?o(i.key,i.arg):l=null}var i,l;this._invoke=r,"function"!=typeof t.return&&(this.return=void 0)}return"function"==typeof Symbol&&Symbol.asyncIterator&&(t.prototype[Symbol.asyncIterator]=function(){return this}),t.prototype.next=function(e){return this._invoke("next",e)},t.prototype.throw=function(e){return this._invoke("throw",e)},t.prototype.return=function(e){return this._invoke("return",e)},{wrap:function(e){return function(){return new t(e.apply(this,arguments))}},await:function(t){return new e(t)}}}(),{require_tld:!0,allow_underscores:!1,allow_trailing_dot:!1}),he={allow_display_name:!1,require_display_name:!1,allow_utf8_local_part:!0,require_tld:!0},ge=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\.\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF\s]*<(.+)>$/i,me=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~]+$/i,_e=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f]))*$/i,ve=/^[a-z\d!#\$%&'\*\+\-\/=\?\^_`{\|}~\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]+$/i,Fe=/^([\s\x01-\x08\x0b\x0c\x0e-\x1f\x7f\x21\x23-\x5b\x5d-\x7e\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|(\\[\x01-\x09\x0b\x0c\x0d-\x7f\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))*$/i,$e=/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/,xe=/^[0-9A-F]{1,4}$/i,ye={protocols:["http","https","ftp"],require_tld:!0,require_protocol:!1,require_host:!0,require_valid_protocol:!0,allow_underscores:!1,allow_trailing_dot:!1,allow_protocol_relative_urls:!1},we=/^\[([^\]]+)\](?::([0-9]+))?$/,Ae=/^([0-9a-fA-F][0-9a-fA-F]:){5}([0-9a-fA-F][0-9a-fA-F])$/,be={"en-US":/^[A-Z]+$/i,"cs-CZ":/^[A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"da-DK":/^[A-ZÆØÅ]+$/i,"de-DE":/^[A-ZÄÖÜß]+$/i,"es-ES":/^[A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"nl-NL":/^[A-ZÉËÏÓÖÜ]+$/i,"hu-HU":/^[A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"pl-PL":/^[A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[А-ЯЁ]+$/i,"sr-RS@latin":/^[A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[A-ZÇĞİıÖŞÜ]+$/i,"uk-UA":/^[А-ЩЬЮЯЄIЇҐ]+$/i,ar:/^[ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},ke={"en-US":/^[0-9A-Z]+$/i,"cs-CZ":/^[0-9A-ZÁČĎÉĚÍŇÓŘŠŤÚŮÝŽ]+$/i,"da-DK":/^[0-9A-ZÆØÅ]$/i,"de-DE":/^[0-9A-ZÄÖÜß]+$/i,"es-ES":/^[0-9A-ZÁÉÍÑÓÚÜ]+$/i,"fr-FR":/^[0-9A-ZÀÂÆÇÉÈÊËÏÎÔŒÙÛÜŸ]+$/i,"hu-HU":/^[0-9A-ZÁÉÍÓÖŐÚÜŰ]+$/i,"nl-NL":/^[0-9A-ZÉËÏÓÖÜ]+$/i,"pl-PL":/^[0-9A-ZĄĆĘŚŁŃÓŻŹ]+$/i,"pt-PT":/^[0-9A-ZÃÁÀÂÇÉÊÍÕÓÔÚÜ]+$/i,"ru-RU":/^[0-9А-ЯЁ]+$/i,"sr-RS@latin":/^[0-9A-ZČĆŽŠĐ]+$/i,"sr-RS":/^[0-9А-ЯЂЈЉЊЋЏ]+$/i,"tr-TR":/^[0-9A-ZÇĞİıÖŞÜ]+$/i,"uk-UA":/^[0-9А-ЩЬЮЯЄIЇҐ]+$/i,ar:/^[٠١٢٣٤٥٦٧٨٩0-9ءآأؤإئابةتثجحخدذرزسشصضطظعغفقكلمنهوىيًٌٍَُِّْٰ]+$/},Se=["AU","GB","HK","IN","NZ","ZA","ZM"],De=0;De<Se.length;De++)fe="en-"+Se[De],be[fe]=be["en-US"],ke[fe]=ke["en-US"];be["pt-BR"]=be["pt-PT"],ke["pt-BR"]=ke["pt-PT"];for(var Ee,Ze=["AE","BH","DZ","EG","IQ","JO","KW","LB","LY","MA","QM","QA","SA","SD","SY","TN","YE"],Oe=0;Oe<Ze.length;Oe++)Ee="ar-"+Ze[Oe],be[Ee]=be.ar,ke[Ee]=ke.ar;var Ie=/^[-+]?[0-9]+$/,Ce=/^[\x00-\x7F]+$/,Re=/[^\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/,je=/[\u0020-\u007E\uFF61-\uFF9F\uFFA0-\uFFDC\uFFE8-\uFFEE0-9a-zA-Z]/,Pe=/[^\x00-\x7F]/,Ue=/[\uD800-\uDBFF][\uDC00-\uDFFF]/,ze=/^(?:[-+]?(?:0|[1-9][0-9]*))$/,Ne=/^[-+]?[0-9]+$/,Be=/^(?:[-+])?(?:[0-9]+)?(?:\.[0-9]*)?(?:[eE][\+\-]?(?:[0-9]+))?$/,Le=/^[-+]?([0-9]+|\.[0-9]+|[0-9]+\.[0-9]+)$/,qe=/^[0-9A-F]+$/i,Te=/^#?([0-9A-F]{3}|[0-9A-F]{6})$/i,He=/^[a-f0-9]{32}$/,Me={3:/^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,4:/^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,5:/^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,all:/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i},Ke=/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|(222[1-9]|22[3-9][0-9]|2[3-6][0-9]{2}|27[01][0-9]|2720)[0-9]{12}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11})|62[0-9]{14}$/,We=/^[A-Z]{2}[0-9A-Z]{9}[0-9]$/,Ge=/^(?:[0-9]{9}X|[0-9]{10})$/,Ye=/^(?:[0-9]{13})$/,Je=[1,3],Qe="^\\d{4}-?\\d{3}[\\dX]$",Xe={"ar-DZ":/^(\+?213|0)(5|6|7)\d{8}$/,"ar-SY":/^(!?(\+?963)|0)?9\d{8}$/,"ar-SA":/^(!?(\+?966)|0)?5\d{8}$/,"en-US":/^(\+?1)?[2-9]\d{2}[2-9](?!11)\d{6}$/,"cs-CZ":/^(\+?420)? ?[1-9][0-9]{2} ?[0-9]{3} ?[0-9]{3}$/,"de-DE":/^(\+?49[ \.\-])?([\(]{1}[0-9]{1,6}[\)])?([0-9 \.\-\/]{3,20})((x|ext|extension)[ ]?[0-9]{1,4})?$/,"da-DK":/^(\+?45)?(\d{8})$/,"el-GR":/^(\+?30)?(69\d{8})$/,"en-AU":/^(\+?61|0)4\d{8}$/,"en-GB":/^(\+?44|0)7\d{9}$/,"en-HK":/^(\+?852\-?)?[569]\d{3}\-?\d{4}$/,"en-IN":/^(\+?91|0)?[789]\d{9}$/,"en-NG":/^(\+?234|0)?[789]\d{9}$/,"en-NZ":/^(\+?64|0)2\d{7,9}$/,"en-ZA":/^(\+?27|0)\d{9}$/,"en-ZM":/^(\+?26)?09[567]\d{7}$/,"es-ES":/^(\+?34)?(6\d{1}|7[1234])\d{7}$/,"fi-FI":/^(\+?358|0)\s?(4(0|1|2|4|5)?|50)\s?(\d\s?){4,8}\d$/,"fr-FR":/^(\+?33|0)[67]\d{8}$/,"he-IL":/^(\+972|0)([23489]|5[0248]|77)[1-9]\d{6}/,"hu-HU":/^(\+?36)(20|30|70)\d{7}$/,"id-ID":/^(\+?62|0[1-9])[\s|\d]+$/,"it-IT":/^(\+?39)?\s?3\d{2} ?\d{6,7}$/,"ja-JP":/^(\+?81|0)\d{1,4}[ \-]?\d{1,4}[ \-]?\d{4}$/,"ms-MY":/^(\+?6?01){1}(([145]{1}(\-|\s)?\d{7,8})|([236789]{1}(\s|\-)?\d{7}))$/,"nb-NO":/^(\+?47)?[49]\d{7}$/,"nl-BE":/^(\+?32|0)4?\d{8}$/,"nn-NO":/^(\+?47)?[49]\d{7}$/,"pl-PL":/^(\+?48)? ?[5-8]\d ?\d{3} ?\d{2} ?\d{2}$/,"pt-BR":/^(\+?55|0)\-?[1-9]{2}\-?[2-9]{1}\d{3,4}\-?\d{4}$/,"pt-PT":/^(\+?351)?9[1236]\d{7}$/,"ro-RO":/^(\+?4?0)\s?7\d{2}(\/|\s|\.|\-)?\d{3}(\s|\.|\-)?\d{3}$/,"en-PK":/^((\+92)|(0092))-{0,1}\d{3}-{0,1}\d{7}$|^\d{11}$|^\d{4}-\d{7}$/,"ru-RU":/^(\+?7|8)?9\d{9}$/,"sr-RS":/^(\+3816|06)[- \d]{5,9}$/,"tr-TR":/^(\+?90|0)?5\d{9}$/,"vi-VN":/^(\+?84|0)?((1(2([0-9])|6([2-9])|88|99))|(9((?!5)[0-9])))([0-9]{7})$/,"zh-CN":/^(\+?0?86\-?)?1[345789]\d{9}$/,"zh-TW":/^(\+?886\-?|0)?9\d{8}$/};Xe["en-CA"]=Xe["en-US"],Xe["fr-BE"]=Xe["nl-BE"],Xe["zh-HK"]=Xe["en-HK"];var Ve={symbol:"$",require_symbol:!1,allow_space_after_symbol:!1,symbol_after_digits:!1,allow_negatives:!0,parens_for_negatives:!1,negative_sign_before_digits:!1,negative_sign_after_digits:!1,allow_negative_sign_placeholder:!1,thousands_separator:",",decimal_separator:".",allow_space_after_digits:!1},et=/^([\+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([\.,]\d+(?!:))?)?(\17[0-5]\d([\.,]\d+)?)?([zZ]|([\+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/,tt=/[^A-Z0-9+\/=]/i,rt=/^\s*data:([a-z]+\/[a-z0-9\-\+]+(;[a-z\-]+=[a-z0-9\-]+)?)?(;base64)?,[a-z0-9!\$&',\(\)\*\+,;=\-\._~:@\/\?%\s]*\s*$/i,ot={all_lowercase:!0,gmail_lowercase:!0,gmail_remove_dots:!0,gmail_remove_subaddress:!0,gmail_convert_googlemaildotcom:!0,outlookdotcom_lowercase:!0,outlookdotcom_remove_subaddress:!0,yahoo_lowercase:!0,yahoo_remove_subaddress:!0,icloud_lowercase:!0,icloud_remove_subaddress:!0},nt=["icloud.com","me.com"],it=["hotmail.at","hotmail.be","hotmail.ca","hotmail.cl","hotmail.co.il","hotmail.co.nz","hotmail.co.th","hotmail.co.uk","hotmail.com","hotmail.com.ar","hotmail.com.au","hotmail.com.br","hotmail.com.gr","hotmail.com.mx","hotmail.com.pe","hotmail.com.tr","hotmail.com.vn","hotmail.cz","hotmail.de","hotmail.dk","hotmail.es","hotmail.fr","hotmail.hu","hotmail.id","hotmail.ie","hotmail.in","hotmail.it","hotmail.jp","hotmail.kr","hotmail.lv","hotmail.my","hotmail.ph","hotmail.pt","hotmail.sa","hotmail.sg","hotmail.sk","live.be","live.co.uk","live.com","live.com.ar","live.com.mx","live.de","live.es","live.eu","live.fr","live.it","live.nl","msn.com","outlook.at","outlook.be","outlook.cl","outlook.co.il","outlook.co.nz","outlook.co.th","outlook.com","outlook.com.ar","outlook.com.au","outlook.com.br","outlook.com.gr","outlook.com.pe","outlook.com.tr","outlook.com.vn","outlook.cz","outlook.de","outlook.dk","outlook.es","outlook.fr","outlook.hu","outlook.id","outlook.ie","outlook.in","outlook.it","outlook.jp","outlook.kr","outlook.lv","outlook.my","outlook.ph","outlook.pt","outlook.sa","outlook.sg","outlook.sk","passport.com"],lt=["rocketmail.com","yahoo.ca","yahoo.co.uk","yahoo.com","yahoo.de","yahoo.fr","yahoo.in","yahoo.it","ymail.com"],at="7.0.0",ut={version:at,toDate:t,toFloat:r,toInt:o,toBoolean:n,equals:i,contains:a,matches:u,isEmail:d,isURL:m,isMACAddress:_,isIP:p,isFQDN:f,isBoolean:v,isAlpha:F,isAlphanumeric:$,isNumeric:x,isLowercase:y,isUppercase:w,isAscii:A,isFullWidth:b,isHalfWidth:k,isVariableWidth:S,isMultibyte:D,isSurrogatePair:E,isInt:Z,isFloat:O,isDecimal:I,isHexadecimal:C,isDivisibleBy:R,isHexColor:j,isMD5:P,isJSON:U,isEmpty:z,isLength:N,isByteLength:c,isUUID:B,isMongoId:L,isAfter:q,isBefore:T,isIn:H,isCreditCard:M,isISIN:K,isISBN:W,isISSN:G,isMobilePhone:Y,isCurrency:Q,isISO8601:X,isBase64:V,isDataURI:ee,ltrim:te,rtrim:re,trim:oe,escape:ne,unescape:ie,stripLow:ae,whitelist:ue,blacklist:le,isWhitelisted:se,normalizeEmail:ce,toString:l};return ut});